;PIC12F683   LAP2      Oo[W

;            _____________
;  VDD 5V  =1;            ;8= 0V VSS
;           2;(GP5)  (GP0);7=X^[g
;           3;(GP4)  (GP1);6=ύX
;  @@@@=4;(GP3)  (GP2);5=PWM ó@@@@@@@@ @@
;            _____________@@@@@@@@@@@   



	list      p=12f683	; |󎞂ɃXgt@C܂
	#include <p12f683.inc>	; 12F683p`t@Cǂݍ݂܂
	errorlevel  -302	; |󎞂302G[oȂ悤ɂ܂

	__CONFIG _CP_OFF & _CPD_OFF & _MCLRE_OFF & _WDT_OFF & _PWRTE_ON & _HS_OSC

	radix	dec		; ȗ̐l\POiɂ܂B

	ORG	000H
	GOTO	INIT 

	ORG	004H
	GOTO	INT	



	ROUND1		EQU	20H
	ROUND2		EQU	21H
	DATA1		EQU	22H
	DATA2		EQU	23H
	DATA3		EQU	24H
	DATA4		EQU	25H
	DATA5		EQU	26H
	DATA6		EQU	27H
	DATA7		EQU	28H
	DATA8		EQU	29H
	DATA9		EQU	2AH
;	DATA10		EQU	2BH
	TONE		EQU	2CH
	DAT		EQU	2DH
	RHYCNT		EQU	2EH
	TAN		EQU	2FH
;			EQU	30H
;			EQU	31H
;			EQU	32H
;			EQU	33H


	W_TEMP		EQU 	70H 
	STATUS_TEMP	EQU	71H
	PCLATH_TEMP	EQU	72H
	OVFL_C		EQU	73H
	DD		EQU	74H
;			EQU	75H
;			EQU	76H
;			EQU	77H
;			EQU	78H





;---- [` ----
INIT:

	BSF	STATUS,RP0			;BANK 1

	MOVLW   B'001000'			;0=, 1=, 2=PWM, 3=PB PLAY, 4=, 5=,
	MOVWF	TRISIO                      	;GPIO

	MOVLW   B'10000111'                 
	MOVWF	OPTION_REG 
                       		
	MOVLW	B'00000000'			;0_, 000=Fosc/2, GP3, GP2, GP1, GP0,
	MOVWF	ANSEL

	MOVLW	B'01100000'			;0_, 110=4MHz, 0_, 0_, 0_, 0_, 
	MOVWF	OSCCON

	MOVLW	D'255'
	MOVWF	PR2		;PWM


	MOVLW	B'00000010'	;TMR2-PR2 v荞݋tO 
	MOVWF	PIE1					

	BCF	STATUS,RP0			;BANK 0

	MOVLW	B'00000111'			;GP2,GP1,GP0,
	MOVWF	CMCON0

	MOVLW	D'1'
	MOVWF	TMR0
	MOVLW	D'5'
	MOVWF	OVFL_C
	
	BSF	INTCON,T0IE			;^C}
	BSF	INTCON,GIE			;S̊

	MOVLW	B'00001100'	;
	MOVWF	CCP1CON		;PWM[h

	MOVLW	B'00000100'	;
	MOVWF	T2CON		;Timer2 ON ,vXP[:[1:1]

	CLRF	TMR2
	CLRF	ROUND1
	CLRF	ROUND2
	CLRF	DATA1
	CLRF	DATA2
	CLRF	DATA3
	CLRF	DATA4
	CLRF	DATA5
	CLRF	DATA6
	CLRF	DATA7
	CLRF	DATA8
	CLRF	DATA9
	CLRF	TONE
	CLRF	DAT
	CLRF	RHYCNT
	CLRF	TAN
	CLRF	DD

	GOTO	MAIN000

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ---- 荞݃[` ----
INT:
@@@@@@@
	MOVWF	W_TEMP
	MOVF	STATUS,W
	MOVWF	STATUS_TEMP
	MOVF	PCLATH,W
	MOVWF	PCLATH_TEMP

	BCF	INTCON,T0IF

	MOVLW	D'5'		
	MOVWF	TMR0
	DECFSZ	OVFL_C,F

	GOTO	INT_1
	MOVLW	D'12'		
	MOVWF	OVFL_C	

	BSF	DD,0
	GOTO	INT_1

INT_1
	MOVF	PCLATH_TEMP,W
	MOVWF	PCLATH
	MOVF	STATUS_TEMP,W
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MAIN000
	CLRF	TMR2
	CLRF	ROUND1
	CLRF	ROUND2
	CLRF	DATA1
	CLRF	DATA2
	CLRF	DATA3
	CLRF	DATA4
	CLRF	DATA5
	CLRF	DATA6
	CLRF	DATA7
	CLRF	DATA8
	CLRF	TONE
	CLRF	DAT
	CLRF	RHYCNT
	CLRF	TAN
	CLRF	DD

	
MAIN00	
	BTFSC	GPIO,3		;荞݃r[g҂		
	GOTO	MAIN00		;
MAIN00_1			;
	BTFSS	DD,0		;
	GOTO	MAIN00_1	;	
	BCF	DD,0		;	
	NOP			;	
	NOP			;	
				;
MAIN00_2			;	
	BTFSS	DD,0		;	
	GOTO	MAIN00_2	;		
	BCF	DD,0		;
	GOTO	MAIN100		;	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MAIN100

	MOVLW	D'4'		;_EJ[|P	
	MOVWF	DATA9

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MAIN100_0

	MOVLW	D'2'		;_EJ[|Q	
	MOVWF	DATA5

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAIN101
	MOVLW	D'2'		;t[YP@JԂ
	MOVWF	DATA3		;

	MOVLW	D'4'		;t[YP@KONBANWA!
	MOVWF	DATA1		;
	MOVLW	D'48'		;t[YP@KONBANWA!	47
	MOVWF	DATA2		;

MAIN101_1

	BSF	STATUS,RP0			;BANK 1
	MOVLW	D'255'
	MOVWF	PR2		;PWM
	BCF	STATUS,RP0			;BANK 0

	CALL	MAIN0_1		;KONBANWA!

MAIN102				;荞݃r[g҂
	BTFSS	DD,0		;
	GOTO	MAIN102		;	
	BCF	DD,0		;
	NOP			;
	NOP			;
				;
MAIN102_1			;
	BTFSS	DD,0		;
	GOTO	MAIN102_1	;	
	BCF	DD,0		;	

MAIN103	

	BSF	STATUS,RP0			;BANK 1
	MOVLW	D'255'
	MOVWF	PR2		;PWM
	BCF	STATUS,RP0			;BANK 0

	CALL	RHY1		;RHY1!

MAIN103_1
	DECFSZ	DATA3,F		;t[YP@QJԂ
	GOTO	MAIN101_1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAIN104
	MOVLW	D'2'		;t[YQ@JԂ
	MOVWF	DATA4		;

	MOVLW	D'5'		;t[YQ@KONBANWA!	6
	MOVWF	DATA1		;
	MOVLW	D'36'		;t[YQ@KONBANWA!	27	
	MOVWF	DATA2		;

MAIN104_1

	CALL	MAIN0_1		;KONBANWA!

MAIN105				;荞݃r[g҂
	BTFSS	DD,0		;
	GOTO	MAIN105		;	
	BCF	DD,0		;
	NOP			;
	NOP			;
				;
MAIN105_1			;
	BTFSS	DD,0		;
	GOTO	MAIN105_1	;	
	BCF	DD,0		;	

MAIN106	

	CALL	RHY2		;RHY2!

MAIN106_1
	DECFSZ	DATA4,F		;t[YQ@QJԂ
	GOTO	MAIN104_1


MAIN107
	DECFSZ	DATA5,F		;_EJ[|Q
	GOTO	MAIN101

MAIN108				;bnc`
	MOVLW	D'4'		;t[YP@KONBANWA!
	MOVWF	DATA1		;
	MOVLW	D'47'		;t[YP@KONBANWA!
	MOVWF	DATA2		;

MAIN109
	CALL	CODA

MAIN110
	GOTO	MAIN000

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RHY1

	CLRF	TMR2
	BSF	STATUS,RP0			;BANK 1
	MOVLW	D'51'
	MOVWF	PR2		;PWM
	BCF	STATUS,RP0			;BANK 0


	CALL	RHY1_TABLE1
	MOVWF	RHYCNT
RHY1_1
	BTFSS	PIR1,TMR2IF
	GOTO	RHY1_1
	BCF	PIR1,TMR2IF

	MOVLW	D'35'
	MOVWF	CCPR1L	

	DECFSZ	RHYCNT,F
	GOTO	RHY1_1

	BTFSC	DD,0
	GOTO	RHY1_3

	CALL	RHY1_TABLE1
	MOVWF	RHYCNT
RHY1_2
	BTFSS	PIR1,TMR2IF
	GOTO	RHY1_2
	BCF	PIR1,TMR2IF

	MOVLW	D'15'
	MOVWF	CCPR1L	

	DECFSZ	RHYCNT,F
	GOTO	RHY1_2

	BTFSS	DD,0
	GOTO	RHY1

RHY1_3
	INCF	TAN,F
	BCF	DD,0

	MOVLW	D'11'		;<<<<<<<<f[^
	SUBWF	TAN,W
	BTFSS	STATUS,C
	GOTO	RHY1
	CLRF	TAN

	CLRF	TMR2
	BSF	STATUS,RP0			;BANK 1
	MOVLW	D'255'
	MOVWF	PR2		;PWM
	BCF	STATUS,RP0			;BANK 0

			
	RETURN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RHY2

	CLRF	TMR2
	BSF	STATUS,RP0			;BANK 1
	MOVLW	D'51'
	MOVWF	PR2		;PWM
	BCF	STATUS,RP0			;BANK 0

	CALL	RHY2_TABLE2
	MOVWF	RHYCNT
RHY2_1
	BTFSS	PIR1,TMR2IF
	GOTO	RHY2_1
	BCF	PIR1,TMR2IF

	MOVLW	D'35'
	MOVWF	CCPR1L	

	DECFSZ	RHYCNT,F
	GOTO	RHY2_1

	BTFSC	DD,0
	GOTO	RHY2_3

	CALL	RHY2_TABLE2
	MOVWF	RHYCNT
RHY2_2
	BTFSS	PIR1,TMR2IF
	GOTO	RHY2_2
	BCF	PIR1,TMR2IF

	MOVLW	D'15'
	MOVWF	CCPR1L	

	DECFSZ	RHYCNT,F
	GOTO	RHY2_2

	BTFSS	DD,0
	GOTO	RHY2

RHY2_3
	INCF	TAN,F
	BCF	DD,0

	MOVLW	D'11'		;<<<<<<<<f[^
	SUBWF	TAN,W
	BTFSS	STATUS,C
	GOTO	RHY2
	CLRF	TAN

	CLRF	TMR2			
	BSF	STATUS,RP0			;BANK 1
	MOVLW	D'255'
	MOVWF	PR2		;PWM
	BCF	STATUS,RP0			;BANK 0

	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CODA
	MOVLW	D'8'		;
	MOVWF	DATA6

CODA1
	CALL	MAIN1
	CALL	MAIN_A

CODA2
	BTFSS	DD,0
	GOTO	CODA2
	BCF	DD,0
	DECFSZ	DATA6,F
	GOTO	CODA1

CODA3

	CALL	MAIN1
	CALL	MAIN_A
	CALL	MAIN2
	CALL	MAIN_B		
	CALL	MAIN3
	CALL	MAIN_C
	CALL	MAIN4
	CALL	MAIN_D
	CALL	MAIN5

CODA4
	MOVLW	D'13'		;EEEEEEEE
	MOVWF	DATA6

CODA5
	CALL	MAIN6

CODA6
	BTFSS	DD,0		
	GOTO	CODA6
	BCF	DD,0
	DECFSZ	DATA6,F
	GOTO	CODA5

CODA7
	MOVLW	D'8'		;EEEEEEEE
	MOVWF	DATA6

CODA8
	CALL	MAIN2

	
CODA9
	BTFSS	DD,0		
	GOTO	CODA9
	BCF	DD,0
	DECFSZ	DATA6,F
	GOTO	CODA8

CODA10
	DECFSZ	DATA9,F		;_EJ[|P
	GOTO	MAIN100_0

CODA11
	MOVLW	D'8'		;t[YR@KONBANWA!
	MOVWF	DATA1		;
	MOVLW	D'56'		;t[YR@KONBANWA!	52	
	MOVWF	DATA2		;

	CALL	MAIN1
	CALL	MAIN_A
	CALL	MAIN2
	CALL	MAIN_B		
	CALL	MAIN3
	CALL	MAIN_C
	CALL	MAIN4
	CALL	MAIN_D
	CALL	MAIN5
	CALL	MAIN_E


CODA_P
	CLRF	RHYCNT
	CLRF	TMR2
	BSF	STATUS,RP0			;BANK 1
	MOVLW	D'51'
	MOVWF	PR2		;PWM
	BCF	STATUS,RP0			;BANK 0

	CALL	CODA_P_TABLE

CODA_P1

	BTFSS	PIR1,TMR2IF
	GOTO	CODA_P1
	BCF	PIR1,TMR2IF

	MOVF	DATA7,W			;D'35'
	MOVWF	CCPR1L	

	DECFSZ	RHYCNT,F
	GOTO	CODA_P1

	CALL	CODA_P_TABLE

CODA_P2

	BTFSS	PIR1,TMR2IF
	GOTO	CODA_P2
	BCF	PIR1,TMR2IF

	MOVF	DATA8,W			;D'15'
	MOVWF	CCPR1L	

	DECFSZ	RHYCNT,F
	GOTO	CODA_P2

	BTFSS	DD,0
	GOTO	CODA_P

CODA_P3
	INCF	TAN,F
	INCF	TAN,F
	INCF	TAN,F
	INCF	TAN,F
	INCF	TAN,F
	INCF	TAN,F
	INCF	TAN,F

	BCF	DD,0

	MOVLW	D'105'		;<<<<<<<<f[^
	SUBWF	TAN,W
	BTFSS	STATUS,C
	GOTO	CODA_P
	CLRF	TAN

CODA_P4

	CLRF	TMR2
	BSF	STATUS,RP0			;BANK 1
	MOVLW	D'255'
	MOVWF	PR2		;PWM
	BCF	STATUS,RP0			;BANK 0

			
	GOTO	MAIN110
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAIN0_1
	MOVLW	B'00001100'	;
	MOVWF	CCP1CON		;PWM[h

	CALL	MAIN1
	CALL	MAIN_A
	CALL	MAIN2
	CALL	MAIN_B		
	CALL	MAIN3
	CALL	MAIN_C
	CALL	MAIN4
	CALL	MAIN_D
	CALL	MAIN5
	CALL	MAIN_E
	CALL	MAIN6

	RETURN
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAIN1
	MOVF	DATA1,W		;[K]
	MOVWF	ROUND1

MAIN1_1
			
	BTFSS	PIR1,TMR2IF
	GOTO	MAIN1_1
	BCF	PIR1,TMR2IF

	CALL	DATA_TABLE1
	MOVWF	CCPR1L	
	
	DECFSZ	ROUND1,F
	GOTO	MAIN1_1

	INCF	DAT,F

	MOVLW	D'108'		;<<<<<<<<f[^
	SUBWF	DAT,W
	BTFSS	STATUS,C
	GOTO	MAIN1
	CLRF	DAT
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAIN2
	MOVF	DATA1,W		;[O-N]
	MOVWF	ROUND1

MAIN2_1
			
	BTFSS	PIR1,TMR2IF
	GOTO	MAIN2_1
	BCF	PIR1,TMR2IF

	CALL	DATA_TABLE2
	MOVWF	CCPR1L	
	
	DECFSZ	ROUND1,F
	GOTO	MAIN2_1

	INCF	DAT,F

	MOVLW	D'168'		;<<<<<<<<f[^
	SUBWF	DAT,W
	BTFSS	STATUS,C
	GOTO	MAIN2
	CLRF	DAT
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAIN3
	MOVF	DATA1,W		;[B]
	MOVWF	ROUND1
MAIN3_1
			
	BTFSS	PIR1,TMR2IF
	GOTO	MAIN3_1
	BCF	PIR1,TMR2IF

	CALL	DATA_TABLE3
	MOVWF	CCPR1L	
	
	DECFSZ	ROUND1,F
	GOTO	MAIN3_1

	INCF	DAT,F

	MOVLW	D'48'		;<<<<<<<<f[^
	SUBWF	DAT,W
	BTFSS	STATUS,C
	GOTO	MAIN3
	CLRF	DAT
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAIN4
	MOVF	DATA1,W		;[A-N]
	MOVWF	ROUND1

MAIN4_1
			
	BTFSS	PIR1,TMR2IF
	GOTO	MAIN4_1
	BCF	PIR1,TMR2IF

	CALL	DATA_TABLE4
	MOVWF	CCPR1L	
	
	DECFSZ	ROUND1,F
	GOTO	MAIN4_1

	INCF	DAT,F

	MOVLW	D'216'		;<<<<<<<<f[^
	SUBWF	DAT,W
	BTFSS	STATUS,C
	GOTO	MAIN4
	CLRF	DAT
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAIN5
	MOVF	DATA1,W		;[W]
	MOVWF	ROUND1

MAIN5_1
			
	BTFSS	PIR1,TMR2IF
	GOTO	MAIN5_1
	BCF	PIR1,TMR2IF

	CALL	DATA_TABLE5
	MOVWF	CCPR1L	
	
	DECFSZ	ROUND1,F
	GOTO	MAIN5_1

	INCF	DAT,F

	MOVLW	D'132'		;<<<<<<<<f[^
	SUBWF	DAT,W
	BTFSS	STATUS,C
	GOTO	MAIN5
	CLRF	DAT
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAIN6
	MOVF	DATA1,W		;[W-A]
	MOVWF	ROUND1

MAIN6_1
			
	BTFSS	PIR1,TMR2IF
	GOTO	MAIN6_1
	BCF	PIR1,TMR2IF

	CALL	DATA_TABLE6
	MOVWF	CCPR1L	
	
	DECFSZ	ROUND1,F
	GOTO	MAIN6_1

	INCF	DAT,F

	MOVLW	D'168'		;<<<<<<<<f[^
	SUBWF	DAT,W
	BTFSS	STATUS,C
	GOTO	MAIN6
	CLRF	DAT
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAIN_A
	MOVF	DATA2,W		;[O]
	MOVWF	ROUND2

MAIN_A_0
	MOVF	DATA1,W
	MOVWF	ROUND1

MAIN_A_1

	BTFSS	PIR1,TMR2IF
	GOTO	MAIN_A_1
	BCF	PIR1,TMR2IF

	CALL	DATA_TABLE_A
	MOVWF	CCPR1L	
	
	DECFSZ	ROUND1,F
	GOTO	MAIN_A_1

	INCF	DAT,F

	MOVLW	D'12'		;<<<<<<<<f[^
	SUBWF	DAT,W
	BTFSS	STATUS,C
	GOTO	MAIN_A_0
	CLRF	DAT
	DECFSZ	ROUND2,F
	GOTO	MAIN_A_0
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAIN_B
	MOVF	DATA2,W		;[N]
	MOVWF	ROUND2

MAIN_B_0
	MOVF	DATA1,W
	MOVWF	ROUND1

MAIN_B_1

	BTFSS	PIR1,TMR2IF
	GOTO	MAIN_B_1
	BCF	PIR1,TMR2IF

	CALL	DATA_TABLE_B
	MOVWF	CCPR1L	
	
	DECFSZ	ROUND1,F
	GOTO	MAIN_B_1

	INCF	DAT,F

	MOVLW	D'12'		;<<<<<<<<f[^
	SUBWF	DAT,W
	BTFSS	STATUS,C
	GOTO	MAIN_B_0
	CLRF	DAT
	DECFSZ	ROUND2,F
	GOTO	MAIN_B_0
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAIN_C
	MOVF	DATA2,W		;[A]
	MOVWF	ROUND2

MAIN_C_0
	MOVF	DATA1,W
	MOVWF	ROUND1

MAIN_C_1

	BTFSS	PIR1,TMR2IF
	GOTO	MAIN_C_1
	BCF	PIR1,TMR2IF

	CALL	DATA_TABLE_C
	MOVWF	CCPR1L	
	
	DECFSZ	ROUND1,F
	GOTO	MAIN_C_1

	INCF	DAT,F

	MOVLW	D'12'		;<<<<<<<<f[^
	SUBWF	DAT,W
	BTFSS	STATUS,C
	GOTO	MAIN_C_0
	CLRF	DAT
	DECFSZ	ROUND2,F
	GOTO	MAIN_C_0
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAIN_D
	MOVF	DATA2,W		;[UN]
	MOVWF	ROUND2

MAIN_D_0
	MOVF	DATA1,W
	MOVWF	ROUND1

MAIN_D_1

	BTFSS	PIR1,TMR2IF
	GOTO	MAIN_D_1
	BCF	PIR1,TMR2IF

	CALL	DATA_TABLE_D
	MOVWF	CCPR1L	
	
	DECFSZ	ROUND1,F
	GOTO	MAIN_D_1

	INCF	DAT,F

	MOVLW	D'12'		;<<<<<<<<f[^
	SUBWF	DAT,W
	BTFSS	STATUS,C
	GOTO	MAIN_D_0
	CLRF	DAT
	DECFSZ	ROUND2,F
	GOTO	MAIN_D_0
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MAIN_E
	MOVF	DATA2,W		;[WA]
	MOVWF	ROUND2

MAIN_E_0
	MOVF	DATA1,W
	MOVWF	ROUND1

MAIN_E_1

	BTFSS	PIR1,TMR2IF
	GOTO	MAIN_E_1
	BCF	PIR1,TMR2IF

	CALL	DATA_TABLE_E
	MOVWF	CCPR1L	
	
	DECFSZ	ROUND1,F
	GOTO	MAIN_E_1

	INCF	DAT,F

	MOVLW	D'12'		;<<<<<<<<f[^
	SUBWF	DAT,W
	BTFSS	STATUS,C
	GOTO	MAIN_E_0
	CLRF	DAT
	DECFSZ	ROUND2,F
	GOTO	MAIN_E_0
	RETURN




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ORG	300H

DATA_TABLE_A
						
	MOVLW	H'03'
	MOVWF	PCLATH	; e[u 0x300`0x3FFԒnɑ
	
	ANDLW	B'11111111'	

	MOVF	DAT,W
	ADDWF	PCL,F

	RETLW	D'230'	;1
	RETLW	D'130'	;
	RETLW	D'30'	;
	RETLW	D'130'	;
	RETLW	D'190'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'70'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ORG	315H

DATA_TABLE_B
						
	MOVLW	H'03'
	MOVWF	PCLATH	; e[u 0x300`0x3FFԒnɑ
	
	ANDLW	B'11111111'	

	MOVF	DAT,W
	ADDWF	PCL,F


	RETLW	D'150'	;1
	RETLW	D'170'	;
	RETLW	D'160'	;
	RETLW	D'130'	;
	RETLW	D'100'	;
	RETLW	D'90'	;
	RETLW	D'90'	;
	RETLW	D'90'	;
	RETLW	D'100'	;
	RETLW	D'130'	;
	RETLW	D'160'	;
	RETLW	D'170'	;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ORG	32AH

DATA_TABLE_C
						
	MOVLW	H'03'
	MOVWF	PCLATH	; e[u 0x300`0x3FFԒnɑ
	
	ANDLW	B'11111111'	

	MOVF	DAT,W
	ADDWF	PCL,F

	RETLW	D'250'	;1
	RETLW	D'10'	;
	RETLW	D'220'	;
	RETLW	D'130'	;
	RETLW	D'40'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ORG	340H

DATA_TABLE_D
						
	MOVLW	H'03'
	MOVWF	PCLATH	; e[u 0x300`0x3FFԒnɑ
	
	ANDLW	B'11111111'	

	MOVF	DAT,W
	ADDWF	PCL,F

	RETLW	D'190'	;1
	RETLW	D'130'	;
	RETLW	D'70'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'140'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'100'	;
	RETLW	D'110'	;
	RETLW	D'130'	;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ORG	35AH

DATA_TABLE_E
						
	MOVLW	H'03'
	MOVWF	PCLATH	; e[u 0x300`0x3FFԒnɑ
	
	ANDLW	B'11111111'	

	MOVF	DAT,W
	ADDWF	PCL,F

	RETLW	D'230'	;1
	RETLW	D'30'	;
	RETLW	D'200'	;
	RETLW	D'130'	;
	RETLW	D'60'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ORG	370H

DATA_TABLE1
						
	MOVLW	H'03'
	MOVWF	PCLATH	; e[u 0x300`0x3FFԒnɑ
	
	ANDLW	B'11111111'	

	MOVF	DAT,W
	ADDWF	PCL,F

	RETLW	D'180'	;1
	RETLW	D'80'	;
	RETLW	D'180'	;
	RETLW	D'80'	;
	RETLW	D'180'	;
	RETLW	D'80'	;
	RETLW	D'180'	;
	RETLW	D'80'	;
	RETLW	D'180'	;
	RETLW	D'80'	;
	RETLW	D'160'	;
	RETLW	D'100'	;

	RETLW	D'145'	;2
	RETLW	D'115'	;
	RETLW	D'145'	;
	RETLW	D'115'	;
	RETLW	D'144'	;
	RETLW	D'116'	;
	RETLW	D'143'	;
	RETLW	D'117'	;
	RETLW	D'142'	;
	RETLW	D'118'	;
	RETLW	D'141'	;
	RETLW	D'119'	;

	RETLW	D'140'	;3
	RETLW	D'120'	;
	RETLW	D'140'	;
	RETLW	D'120'	;
	RETLW	D'139'	;
	RETLW	D'121'	;
	RETLW	D'138'	;
	RETLW	D'122'	;
	RETLW	D'137'	;
	RETLW	D'123'	;
	RETLW	D'136'	;
	RETLW	D'124'	;

	RETLW	D'135'	;4
	RETLW	D'125'	;
	RETLW	D'135'	;
	RETLW	D'125'	;
	RETLW	D'135'	;
	RETLW	D'125'	;
	RETLW	D'135'	;
	RETLW	D'125'	;
	RETLW	D'135'	;
	RETLW	D'125'	;
	RETLW	D'135'	;
	RETLW	D'125'	;

	RETLW	D'130'	;5
	RETLW	D'130'	;
	RETLW	D'130'	;
	RETLW	D'130'	;
	RETLW	D'130'	;
	RETLW	D'130'	;
	RETLW	D'130'	;
	RETLW	D'130'	;
	RETLW	D'130'	;
	RETLW	D'130'	;
	RETLW	D'135'	;
	RETLW	D'125'	;

	RETLW	D'210'	;6
	RETLW	D'180'	;
	RETLW	D'130'	;
	RETLW	D'50'	;
	RETLW	D'80'	;
	RETLW	D'130'	;
	RETLW	D'180'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'80'	;
	RETLW	D'90'	;
	RETLW	D'130'	;


	RETLW	D'210'	;7
	RETLW	D'180'	;
	RETLW	D'130'	;
	RETLW	D'50'	;
	RETLW	D'80'	;
	RETLW	D'130'	;
	RETLW	D'180'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'80'	;
	RETLW	D'90'	;
	RETLW	D'130'	;


	RETLW	D'210'	;8
	RETLW	D'130'	;
	RETLW	D'50'	;
	RETLW	D'130'	;
	RETLW	D'180'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'80'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;


	RETLW	D'225'	;9
	RETLW	D'130'	;
	RETLW	D'35'	;
	RETLW	D'130'	;
	RETLW	D'190'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'70'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ORG	400H

DATA_TABLE2
						
	MOVLW	H'04'
	MOVWF	PCLATH	; e[u 0x400`0x4FFԒnɑ
	
	ANDLW	B'11111111'	

	MOVF	DAT,W
	ADDWF	PCL,F

	RETLW	D'230'	;1
	RETLW	D'190'	;
	RETLW	D'130'	;
	RETLW	D'30'	;
	RETLW	D'70'	;
	RETLW	D'130'	;
	RETLW	D'190'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'70'	;
	RETLW	D'90'	;
	RETLW	D'130'	;

	RETLW	D'225'	;2
	RETLW	D'190'	;
	RETLW	D'130'	;
	RETLW	D'35'	;
	RETLW	D'70'	;
	RETLW	D'130'	;
	RETLW	D'190'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'70'	;
	RETLW	D'90'	;
	RETLW	D'130'	;

	RETLW	D'220'	;3
	RETLW	D'185'	;
	RETLW	D'130'	;
	RETLW	D'40'	;
	RETLW	D'75'	;
	RETLW	D'130'	;
	RETLW	D'185'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'75'	;
	RETLW	D'90'	;
	RETLW	D'130'	;

	RETLW	D'210'	;4
	RETLW	D'180'	;
	RETLW	D'130'	;
	RETLW	D'50'	;
	RETLW	D'80'	;
	RETLW	D'130'	;
	RETLW	D'180'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'80'	;
	RETLW	D'90'	;
	RETLW	D'130'	;

	RETLW	D'200'	;5
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'60'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'160'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'100'	;
	RETLW	D'130'	;

	RETLW	D'190'	;6
	RETLW	D'160'	;
	RETLW	D'130'	;
	RETLW	D'70'	;
	RETLW	D'100'	;
	RETLW	D'130'	;
	RETLW	D'160'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'100'	;
	RETLW	D'110'	;
	RETLW	D'130'	;

	RETLW	D'180'	;7
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'120'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'140'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'120'	;
	RETLW	D'130'	;

	RETLW	D'170'	;8
	RETLW	D'140'	;
	RETLW	D'137'	;
	RETLW	D'130'	;
	RETLW	D'123'	;
	RETLW	D'120'	;
	RETLW	D'90'	;
	RETLW	D'120'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'137'	;
	RETLW	D'130'	;

	RETLW	D'140'	;9
	RETLW	D'150'	;
	RETLW	D'140'	;
	RETLW	D'130'	;
	RETLW	D'120'	;
	RETLW	D'110'	;
	RETLW	D'110'	;
	RETLW	D'110'	;
	RETLW	D'120'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'150'	;

	RETLW	D'140'	;10
	RETLW	D'150'	;
	RETLW	D'140'	;
	RETLW	D'130'	;
	RETLW	D'120'	;
	RETLW	D'110'	;
	RETLW	D'110'	;
	RETLW	D'110'	;
	RETLW	D'120'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'150'	;

	RETLW	D'140'	;11
	RETLW	D'160'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'100'	;
	RETLW	D'100'	;
	RETLW	D'100'	;
	RETLW	D'110'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'160'	;

	RETLW	D'140'	;12
	RETLW	D'160'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'100'	;
	RETLW	D'100'	;
	RETLW	D'100'	;
	RETLW	D'110'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'160'	;

	RETLW	D'140'	;13
	RETLW	D'170'	;
	RETLW	D'160'	;
	RETLW	D'130'	;
	RETLW	D'100'	;
	RETLW	D'90'	;
	RETLW	D'90'	;
	RETLW	D'90'	;
	RETLW	D'100'	;
	RETLW	D'130'	;
	RETLW	D'160'	;
	RETLW	D'170'	;

	RETLW	D'140'	;14
	RETLW	D'170'	;
	RETLW	D'160'	;
	RETLW	D'130'	;
	RETLW	D'100'	;
	RETLW	D'90'	;
	RETLW	D'90'	;
	RETLW	D'90'	;
	RETLW	D'100'	;
	RETLW	D'130'	;
	RETLW	D'160'	;
	RETLW	D'170'	;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ORG	4B0H

DATA_TABLE3
						
	MOVLW	H'04'
	MOVWF	PCLATH	; e[u 0x400`0x4FFԒnɑ
	
	ANDLW	B'11111111'	

	MOVF	DAT,W
	ADDWF	PCL,F

	RETLW	D'170'	;1
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'160'	;
	RETLW	D'130'	;
	RETLW	D'100'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'130'	;

	RETLW	D'190'	;2
	RETLW	D'130'	;
	RETLW	D'70'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'130'	;

	RETLW	D'210'	;3
	RETLW	D'50'	;
	RETLW	D'190'	;
	RETLW	D'130'	;
	RETLW	D'70'	;
	RETLW	D'130'	;
	RETLW	D'160'	;
	RETLW	D'130'	;
	RETLW	D'100'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

	RETLW	D'230'	;4
	RETLW	D'30'	;
	RETLW	D'200'	;
	RETLW	D'130'	;
	RETLW	D'60'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ORG	500H

DATA_TABLE4
						
	MOVLW	H'05'
	MOVWF	PCLATH	; e[u 0x500`0x5FFԒnɑ
	
	ANDLW	B'11111111'	

	MOVF	DAT,W
	ADDWF	PCL,F

	RETLW	D'245'	;1
	RETLW	D'15'	;
	RETLW	D'215'	;
	RETLW	D'130'	;
	RETLW	D'45'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

	RETLW	D'243'	;2
	RETLW	D'17'	;
	RETLW	D'213'	;
	RETLW	D'130'	;
	RETLW	D'47'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

	RETLW	D'241'	;3
	RETLW	D'19'	;
	RETLW	D'211'	;
	RETLW	D'130'	;
	RETLW	D'49'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

	RETLW	D'240'	;4
	RETLW	D'20'	;
	RETLW	D'210'	;
	RETLW	D'130'	;
	RETLW	D'50'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

	RETLW	D'238'	;5
	RETLW	D'22'	;
	RETLW	D'208'	;
	RETLW	D'130'	;
	RETLW	D'52'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

	RETLW	D'236'	;6
	RETLW	D'24'	;
	RETLW	D'206'	;
	RETLW	D'130'	;
	RETLW	D'54'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

	RETLW	D'233'	;7
	RETLW	D'27'	;
	RETLW	D'203'	;
	RETLW	D'130'	;
	RETLW	D'57'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

	RETLW	D'230'	;8
	RETLW	D'30'	;
	RETLW	D'200'	;
	RETLW	D'130'	;
	RETLW	D'60'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

	RETLW	D'226'	;9
	RETLW	D'34'	;
	RETLW	D'196'	;
	RETLW	D'130'	;
	RETLW	D'64'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

	RETLW	D'223'	;10
	RETLW	D'37'	;
	RETLW	D'193'	;
	RETLW	D'130'	;
	RETLW	D'67'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

	RETLW	D'220'	;11
	RETLW	D'40'	;
	RETLW	D'190'	;
	RETLW	D'130'	;
	RETLW	D'70'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

	RETLW	D'215'	;12
	RETLW	D'45'	;
	RETLW	D'185'	;
	RETLW	D'130'	;
	RETLW	D'75'	;
	RETLW	D'130'	;
	RETLW	D'165'	;
	RETLW	D'130'	;
	RETLW	D'95'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

	RETLW	D'210'	;13
	RETLW	D'50'	;
	RETLW	D'180'	;
	RETLW	D'130'	;
	RETLW	D'80'	;
	RETLW	D'130'	;
	RETLW	D'160'	;
	RETLW	D'130'	;
	RETLW	D'100'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'120'	;

	RETLW	D'205'	;14
	RETLW	D'55'	;
	RETLW	D'175'	;
	RETLW	D'130'	;
	RETLW	D'85'	;
	RETLW	D'130'	;
	RETLW	D'155'	;
	RETLW	D'130'	;
	RETLW	D'105'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'120'	;

	RETLW	D'200'	;15
	RETLW	D'130'	;
	RETLW	D'60'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'130'	;

	RETLW	D'195'	;16
	RETLW	D'130'	;
	RETLW	D'65'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'130'	;

	RETLW	D'192'	;17
	RETLW	D'130'	;
	RETLW	D'68'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'130'	;

	RETLW	D'191'	;18
	RETLW	D'130'	;
	RETLW	D'69'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'130'	;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ORG	600H

DATA_TABLE5
						
	MOVLW	H'06'
	MOVWF	PCLATH	; e[u 0x600`0x6FFԒnɑ
	
	ANDLW	B'11111111'	

	MOVF	DAT,W
	ADDWF	PCL,F

	RETLW	D'190'	;1
	RETLW	D'130'	;
	RETLW	D'70'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'140'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'100'	;
	RETLW	D'110'	;
	RETLW	D'130'	;

	RETLW	D'191'	;2
	RETLW	D'130'	;
	RETLW	D'69'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'130'	;

	RETLW	D'195'	;3
	RETLW	D'65'	;
	RETLW	D'165'	;
	RETLW	D'130'	;
	RETLW	D'95'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'120'	;

	RETLW	D'200'	;4
	RETLW	D'60'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'120'	;

	RETLW	D'205'	;5
	RETLW	D'55'	;
	RETLW	D'175'	;
	RETLW	D'130'	;
	RETLW	D'85'	;
	RETLW	D'130'	;
	RETLW	D'155'	;
	RETLW	D'130'	;
	RETLW	D'105'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'120'	;

	RETLW	D'208'	;6
	RETLW	D'52'	;
	RETLW	D'178'	;
	RETLW	D'130'	;
	RETLW	D'82'	;
	RETLW	D'130'	;
	RETLW	D'158'	;
	RETLW	D'130'	;
	RETLW	D'102'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'120'	;

	RETLW	D'210'	;7
	RETLW	D'50'	;
	RETLW	D'180'	;
	RETLW	D'130'	;
	RETLW	D'80'	;
	RETLW	D'130'	;
	RETLW	D'160'	;
	RETLW	D'130'	;
	RETLW	D'100'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'120'	;

	RETLW	D'215'	;8
	RETLW	D'45'	;
	RETLW	D'185'	;
	RETLW	D'130'	;
	RETLW	D'75'	;
	RETLW	D'130'	;
	RETLW	D'165'	;
	RETLW	D'130'	;
	RETLW	D'95'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

	RETLW	D'218'	;9
	RETLW	D'42'	;
	RETLW	D'188'	;
	RETLW	D'130'	;
	RETLW	D'72'	;
	RETLW	D'130'	;
	RETLW	D'168'	;
	RETLW	D'130'	;
	RETLW	D'92'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

	RETLW	D'220'	;10
	RETLW	D'40'	;
	RETLW	D'190'	;
	RETLW	D'130'	;
	RETLW	D'70'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;


	RETLW	D'226'	;11
	RETLW	D'34'	;
	RETLW	D'196'	;
	RETLW	D'130'	;
	RETLW	D'64'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ORG	690H

CODA_P_TABLE
						
	MOVLW	H'06'
	MOVWF	PCLATH	; e[u 0x600`0x6FFԒnɑ
	
	ANDLW	B'11111111'	

	MOVF	TAN,W
	ADDWF	PCL,F

	MOVLW	D'86'		;1
	MOVWF	RHYCNT
	MOVLW	D'35'
	MOVWF	DATA7
	MOVLW	D'15'
	MOVWF	DATA8
	RETURN

	MOVLW	D'86'		;2
	MOVWF	RHYCNT
	MOVLW	D'35'
	MOVWF	DATA7
	MOVLW	D'15'
	MOVWF	DATA8
	RETURN

	MOVLW	D'86'		;3
	MOVWF	RHYCNT
	MOVLW	D'35'
	MOVWF	DATA7
	MOVLW	D'15'
	MOVWF	DATA8
	RETURN

	MOVLW	D'86'		;4
	MOVWF	RHYCNT
	MOVLW	D'35'
	MOVWF	DATA7
	MOVLW	D'15'
	MOVWF	DATA8
	RETURN

	MOVLW	D'86'		;5
	MOVWF	RHYCNT
	MOVLW	D'35'
	MOVWF	DATA7
	MOVLW	D'15'
	MOVWF	DATA8
	RETURN

	MOVLW	D'86'		;6
	MOVWF	RHYCNT
	MOVLW	D'35'
	MOVWF	DATA7
	MOVLW	D'15'
	MOVWF	DATA8
	RETURN

	MOVLW	D'108'		;7
	MOVWF	RHYCNT
	MOVLW	D'35'
	MOVWF	DATA7
	MOVLW	D'15'
	MOVWF	DATA8
	RETURN

	MOVLW	D'108'		;8
	MOVWF	RHYCNT
	MOVLW	D'32'
	MOVWF	DATA7
	MOVLW	D'14'
	MOVWF	DATA8
	RETURN

	MOVLW	D'108'		;9
	MOVWF	RHYCNT
	MOVLW	D'29'
	MOVWF	DATA7
	MOVLW	D'13'
	MOVWF	DATA8
	RETURN

	MOVLW	D'108'		;10
	MOVWF	RHYCNT
	MOVLW	D'26'
	MOVWF	DATA7
	MOVLW	D'12'
	MOVWF	DATA8
	RETURN

	MOVLW	D'108'		;11
	MOVWF	RHYCNT
	MOVLW	D'23'
	MOVWF	DATA7
	MOVLW	D'11'
	MOVWF	DATA8
	RETURN

	MOVLW	D'108'		;12
	MOVWF	RHYCNT
	MOVLW	D'20'
	MOVWF	DATA7
	MOVLW	D'10'
	MOVWF	DATA8
	RETURN

	MOVLW	D'108'		;13
	MOVWF	RHYCNT
	MOVLW	D'17'
	MOVWF	DATA7
	MOVLW	D'9'
	MOVWF	DATA8
	RETURN

	MOVLW	D'108'		;14
	MOVWF	RHYCNT
	MOVLW	D'12'
	MOVWF	DATA7
	MOVLW	D'8'
	MOVWF	DATA8
	RETURN

	MOVLW	D'108'		;15
	MOVWF	RHYCNT
	MOVLW	D'9'
	MOVWF	DATA7
	MOVLW	D'7'
	MOVWF	DATA8
	RETURN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ORG	700H

DATA_TABLE6
						
	MOVLW	H'07'
	MOVWF	PCLATH	; e[u 0x700`0x7FFԒnɑ
	
	ANDLW	B'11111111'	

	MOVF	DAT,W
	ADDWF	PCL,F

	RETLW	D'230'	;1
	RETLW	D'30'	;
	RETLW	D'200'	;
	RETLW	D'130'	;
	RETLW	D'60'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

	RETLW	D'226'	;2
	RETLW	D'34'	;
	RETLW	D'196'	;
	RETLW	D'130'	;
	RETLW	D'64'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

	RETLW	D'220'	;3
	RETLW	D'40'	;
	RETLW	D'190'	;
	RETLW	D'130'	;
	RETLW	D'70'	;
	RETLW	D'130'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

	RETLW	D'215'	;4
	RETLW	D'45'	;
	RETLW	D'185'	;
	RETLW	D'130'	;
	RETLW	D'75'	;
	RETLW	D'130'	;
	RETLW	D'165'	;
	RETLW	D'130'	;
	RETLW	D'95'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'110'	;

	RETLW	D'210'	;5
	RETLW	D'50'	;
	RETLW	D'180'	;
	RETLW	D'130'	;
	RETLW	D'80'	;
	RETLW	D'130'	;
	RETLW	D'160'	;
	RETLW	D'130'	;
	RETLW	D'100'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'120'	;

	RETLW	D'205'	;6
	RETLW	D'55'	;
	RETLW	D'175'	;
	RETLW	D'130'	;
	RETLW	D'85'	;
	RETLW	D'130'	;
	RETLW	D'155'	;
	RETLW	D'130'	;
	RETLW	D'105'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'120'	;

	RETLW	D'200'	;7
	RETLW	D'60'	;
	RETLW	D'170'	;
	RETLW	D'130'	;
	RETLW	D'90'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'120'	;

	RETLW	D'195'	;8
	RETLW	D'65'	;
	RETLW	D'165'	;
	RETLW	D'130'	;
	RETLW	D'95'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'120'	;

	RETLW	D'190'	;9
	RETLW	D'70'	;
	RETLW	D'160'	;
	RETLW	D'130'	;
	RETLW	D'100'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'120'	;

	RETLW	D'185'	;10
	RETLW	D'75'	;
	RETLW	D'160'	;
	RETLW	D'130'	;
	RETLW	D'100'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'120'	;

	RETLW	D'180'	;11
	RETLW	D'80'	;
	RETLW	D'160'	;
	RETLW	D'130'	;
	RETLW	D'100'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'120'	;

	RETLW	D'175'	;12
	RETLW	D'85'	;
	RETLW	D'160'	;
	RETLW	D'130'	;
	RETLW	D'100'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'120'	;

	RETLW	D'170'	;13
	RETLW	D'90'	;
	RETLW	D'160'	;
	RETLW	D'130'	;
	RETLW	D'100'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'120'	;

	RETLW	D'165'	;14
	RETLW	D'95'	;
	RETLW	D'160'	;
	RETLW	D'130'	;
	RETLW	D'100'	;
	RETLW	D'130'	;
	RETLW	D'150'	;
	RETLW	D'130'	;
	RETLW	D'110'	;
	RETLW	D'130'	;
	RETLW	D'140'	;
	RETLW	D'120'	;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ORG	7B0H

RHY1_TABLE1
						
	MOVLW	H'07'
	MOVWF	PCLATH	; e[u 0x700`0x7FFԒnɑ
	
	ANDLW	B'11111111'	

	MOVF	TAN,W
	ADDWF	PCL,F

	RETLW	D'58'	;1
	RETLW	D'96'	;2
	RETLW	D'115'	;1
	RETLW	D'58'	;2
	RETLW	D'76'	;2
	RETLW	D'96'	;1
	RETLW	D'76'	;2
	RETLW	D'96'	;1
	RETLW	D'115'	;1
	RETLW	D'96'	;1
	RETLW	D'115'	;2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ORG	7C3H

RHY2_TABLE2
						
	MOVLW	H'07'
	MOVWF	PCLATH	; e[u 0x700`0x7FFԒnɑ
	
	ANDLW	B'11111111'	

	MOVF	TAN,W
	ADDWF	PCL,F

	RETLW	D'73'	;1
	RETLW	D'86'	;2
	RETLW	D'129'	;3
	RETLW	D'73'	;1
	RETLW	D'86'	;2
	RETLW	D'129'	;3
	RETLW	D'86'	;4
	RETLW	D'108'	;5
	RETLW	D'129'	;6
	RETLW	D'108'	;7
	RETLW	D'129'	;8

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;











	END	













